C
C***************************************************************************
C
C                              GRAPHL V1.0 24/9/89
C
C **************************************************************************
C    
      SUBROUTINE CONTUR(XA,N,M,CLEVEL,XSC,YSC,JLAB,JDASH,JSTEP)
C
C CALLS INITF,PROCS
C
C XA(N,M)  ARRAY BEING CONTOURED, N=1,M=1 IS BOTTOM LEFT, N INCREASES
C TO THE RIGHT, X DIRECTION; M INCREASES UPWARD Y DIRECTION
C XSC,YSC SIZE IN MM OF REGION IN WHICH THE CONTOURS ARE PLOTTED
C JLAB=0 NO LABELS ON CONTOURS, JLAB=1 CONTOURS LABELLED
C JDASH=1 NEGATIVE CONTOURS DASHED, =0 SOLID
C JSTEP SETS THE NUMBER OF MOVES BEFORE THE PEN IS LIFTED FOR
C DASHED CONTOURS
C
      COMMON/CONTL/CON,NN,MM,SCX,SCY,ILAB,IDASH,NSTEP
      COMMON/WSPACE/W(1)
      EQUIVALENCE (W(1),L(1)) 
      DIMENSION XA(N,M),L(1)
C
C INITIALISING COMMON BLOCK
C
      NN=N
      MM=M
      CON=CLEVEL
      SCX=XSC/(N-1)
      SCY=YSC/(M-1)
      ILAB=JLAB
      IDASH=JDASH
      NSTEP=JSTEP
C
      N1=NN-1
      N2=NN-2
      M1=MM-1
      CALL INITF(L,N,M,NN,MM,ID,1)
C
      DO 19 J=1,M1
      IF(XA(1,J).GE.CON.AND.XA(1,J+1).LT.CON)
     1         CALL PROCS(1,J,1,J+1,0,J+1,1,XA,N,M,L)
      IF(XA(NN,J).LT.CON.AND.XA(NN,J+1).GE.CON)
     1          CALL PROCS(NN,J+1,NN,J,NN+1,J,2,XA,N,M,L)
 19   CONTINUE
C
      DO 21 I=1,N1
      IF(XA(I,1).LT.CON.AND.XA(I+1,1).GE.CON)
     1         CALL PROCS(I+1,1,I,1,I+1,0,3,XA,N,M,L)
      IF(XA(I,MM).GE.CON.AND.XA(I+1,MM).LT.CON)
     1         CALL PROCS(I,MM,I+1,MM,I,MM+1,4,XA,N,M,L)
 21   CONTINUE
C
      DO 31 J=2,M1
      DO 31 I=1,N2
      IF(XA(I,J).LT.CON.OR.XA(I+1,J).GE.CON) GO TO 31
      CALL INITF(L,N,M,I,J,ISW,3)
      GO TO (30,31),ISW
   30 CALL INITF(L,N,M,I,J,ISW,2)
      CALL PROCS(I,J,I+1,J,I+1,J-1,5,XA,N,M,L)
 31   CONTINUE
      RETURN
      END
C
C*****************************************************************
C
      SUBROUTINE PROCS(II1,JJ1,II2,JJ2,IIL,JJL,ITYPE,
     CXA,N,M,L)
C
C CALLS LABEL,INITF,PLOT
C
      COMMON/CONTL/CON,NN,MM,SCX,SCY,ILAB,IDASH,NSTEP
      DIMENSION XA(N,M),L(1)
      I1=II1
      J1=JJ1
      I2=II2
      J2=JJ2
      IL=IIL
      JL=JJL
      X=(CON-XA(I2,J2))/(XA(I1,J1)-XA(I2,J2))
      YS=(J2+X*(J1-J2)-1)*SCY
      XS=(I2+X*(I1-I2)-1)*SCX
      CALL PLOT(XS,YS,2)
      NP=0
      NCOUNT=1
      IF(ILAB.EQ.0) GO TO 5
      CALL LABEL(XS,YS)
 5    IN=I1+I2-IL
      JN=J1+J2-JL
      IF(IN.LE.0.OR.IN.GT.NN.OR.JN.LE.0.OR.JN.GT.MM) RETURN
      IF(XA(IN,JN).GE.CON) GO TO 15
      IL=I2
      JL=J2
      I2=IN
      J2=JN
      GO TO 20
 15   IL=I1
      JL=J1
      I1=IN
      J1=JN
 20   X=(CON-XA(I2,J2))/(XA(I1,J1)-XA(I2,J2))
      IF(J1.EQ.J2.AND.J1.NE.1.AND.J1.NE.MM.AND.MAX0(I1,I2).NE.NN)
     1CALL INITF(L,N,M,MIN0(I1,I2),J1,JN,2)
      YS=(J2+X*(J1-J2)-1)*SCY
      XS=(I2+X*(I1-I2)-1)*SCX
      CALL PLOT(XS,YS,NP)
      NCOUNT=NCOUNT+1
      NTST=NCOUNT-NSTEP*(NCOUNT/NSTEP)
      IF((NTST.EQ.0).AND.(IDASH.EQ.1)) NP=2-NP
      IF(ITYPE.NE.5.OR.I1.NE.II1.OR.J1.NE.JJ1.OR.I2.NE.II2.OR.J2.NE.JJ2)
     1                       GO TO 5
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE LABEL(XP,YP)
C
C LABELS CONTOURS ON PLOT
C
      COMMON/CONTL/CON,NN,MM,SCX,SCY,ILAB,IDASH,NSTEP
      CALL SCLCHR(1.5,1.7)
      IF(ABS(CON).LT.0.01) GO TO 5
      LABSC=ALOG10(ABS(CON)+0.1)
      IF(LABSC.LE.0) GO TO 5
      IF(LABSC.GE.4) GO TO 25
      CALL LOCCHR(XP,YP+1.,2)
      GO TO (10,15,20),LABSC
5     WRITE(8,100) CON
100   FORMAT('LB ',F5.2,' ')
      GO TO 50
10    WRITE(8,120) CON
120   FORMAT('LB ',F5.1,' ')
      GO TO 50
15    WRITE(8,140) CON
140   FORMAT('LB ',F5.0,' ')
      GO TO 50
20    WRITE(8,160) CON
160   FORMAT('LB ',F6.0,' ')
      GO TO 50
25    WRITE(8,180) CON
180   FORMAT('LB ',G7.1,' ')
50    CONTINUE
      CALL SCLCHR(2.,2.5)
      CALL PLOT(XP,YP,2)
      RETURN
      END
C
C*********************************************************************
C
      SUBROUTINE INITF(L,N,M,IMAX,JMAX,ISW,ITRIP)
      DIMENSION L(1)
      GO TO (11,12,13),ITRIP
   11 DO 1 J=1,JMAX
      DO 1 I=1,IMAX
      K=I+N*(J-1)
1     L(K)=0
      RETURN
12    K=IMAX+N*(JMAX-1)
      L(K)=1
      RETURN
13    K=IMAX+N*(JMAX-1)
      IF(L(K).EQ.0) GO TO 4
      ISW=2
      RETURN
    4 ISW=1
      RETURN
      END
C
C**********************************************************************
C
      SUBROUTINE XYPLOT(X,Y,N,XMX,XMN,YMX,YMN,XTICK,YTICK
     C,XSIZE,YSIZE,INEW,ICONT)
C
C DETERMINES SIZE OF PLOT IF XMX=XMN,YMX=YMN
C PLOTS AXES WITH LABELLED TICK MARKS AT INTERVALS XTICK,YTICK 
C IF INEW=1.
C PLOT IS OF SIZE XSIZE,YSIZE IN MM
C PLOTS LINE X,Y,N FOR ALL VALUES OF INEW IF ICONT=1
C PLOTS 2 MM CROSS IF ICONT=0
C PLOTS 1.25MM RADIUS CIRCLE IF ICONT=-1
C PLOTS TRIANGLES 1.5MM SIDE IF ICONT=-2
C PLOTS SQUARES 1.5 mm SIDE IF ICONT=-3
C PLOTS DIAMONDS 1.5 mm SIDE IF ICONT=-4
C PLOTS ANOTHER TYPE OF CROSS 2 mm SIDE IF ICONT=-5
C PLOTS UPSIDE DOWN TRIANGLE 1.5 mm SIDE IF ICONT=-6
C PLOTS  2 mm STAR IF ICONT=-7
C ACTUAL SIZE OF PLOT IS XSIZE-10.,YSIZE-10.
C
C       THE SYMBOL SIZE CAN BE CHANGED WHEN INEW=0 BY SETTING THE VALUE
C       OF RSYM IN MM AFTER THE FIRST CALL TO XYPLOT IN COMMON/SYMSIZ/
C
      DIMENSION X(*),Y(*),RAD(3)
      EXTERNAL RANGE
      COMMON/SYMSIZ/RSYM
      IF(INEW.EQ.1) THEN
        RSYM=-1.
        IF(XMX.EQ.XMN) THEN
          CALL RANGE(X,N,XMAX,IMAX,XMIN,IMIN)
          XMAX=AMAX1(XMX,XMAX)
          XMIN=AMIN1(XMN,XMIN)
          XTICK=(XMAX-XMIN)/5.
        ELSE
          XMAX=XMX
          XMIN=XMN
        ENDIF
        IF(YMX.EQ.YMN) THEN
          CALL RANGE(Y,N,YMAX,JMAX,YMIN,JMIN)
          YMAX=AMAX1(YMX,YMAX)
          YMIN=AMIN1(YMN,YMIN)
          YTICK=(YMAX-YMIN)/5.
        ELSE
          YMAX=YMX
          YMIN=YMN
        ENDIF
        XP=15.
        YP=12.
        CALL PLOT(XP,YP,2)
        CALL ORIGIN(XP,YP)
        SX=XSIZE/(XMAX-XMIN)
        SY=YSIZE/(YMAX-YMIN)
C
C       X AXIS
C
        IT=-1
        YP=0.
10      IT=IT+1
        XL=IT*XTICK+XMIN
        XP=(XL-XMIN)*SX
        IF(XP.GT.(XSIZE+.0000001)) GO TO 20
        IF(XP.GE.0.) THEN
          CALL PLOT(XP,YP,0)
          CALL PLOT(XP,YP+2.,0)
          CALL PLOT(XP,YP,0)
          CALL LOCCHR(XP-15.,YP-6.,2)
          WRITE(8,100) XL
100       FORMAT('LB ',G11.4,' ')
          CALL PLOT(XP,YP,2)
        ENDIF
        GO TO 10
20      XP=XSIZE+.01
        CALL PLOT(XP,YP,0)
C   
        JT=-1
22      JT=JT+1
        YL=JT*YTICK+YMIN
        YP=(YL-YMIN)*SY
        IF(YP.GT.(YSIZE+.0000001)) GO TO 24
        CALL PLOT(XP,YP,0)
        CALL PLOT(XP-2.,YP,0)
        CALL PLOT(XP,YP,0)
        GO TO 22
24      YP=YSIZE+.01
        CALL PLOT(XP,YP,0)
C
C       Y AXIS
C
        CALL PLOT(0.,0.,2)
        XP=0.
        JT=-1
30      JT=JT+1
        YL=JT*YTICK+YMIN
        YP=(YL-YMIN)*SY
        IF(YP.GT.(YSIZE+.01)) GO TO 40
        CALL PLOT(XP,YP,0)
        CALL PLOT(XP+2.,YP,0)
        CALL PLOT(XP,YP,0)
        CALL LOCCHR(XP-25.,YP-2.,2)
        WRITE(8,100) YL
        CALL PLOT(XP,YP,2)
        GO TO 30
40      YP=YSIZE+.01
        CALL PLOT(XP,YP,0)
C       
        IT=-1
45      IT=IT+1
        XL=IT*XTICK+XMIN
        XP=(XL-XMIN)*SX
        IF(XP.GT.(XSIZE+.01)) GO TO 50
        IF(XP.GE.0.) THEN
          CALL PLOT(XP,YP,0)
          CALL PLOT(XP,YP-2.,0)
          CALL PLOT(XP,YP,0)
        ENDIF
        GO TO 45
50      XP=XSIZE+.01
        CALL PLOT(XP,YP,0)
      ENDIF
C  
      ID=2
      DATA RAD/2.0,1.25,1.5/
      IF(RSYM.NE.-1.) THEN
C
C       CHANGES SYMBOL SIZE IF RSYM.NE.-1.
C
        DO I=1,3
          RAD(I)=RSYM
        END DO
      ENDIF
      I=0
90    I=I+1
      IF(I.GT.N) RETURN
      XP=(X(I)-XMIN)*SX
      YP=(Y(I)-YMIN)*SY
      IF((XP.LT.-0.1).OR.(YP.LT.-0.1)) THEN
        ID=2
        GO TO 90
C      ELSEIF((XP.GT.XSIZE+10.).OR.(YP.GT.YSIZE+10.)) THEN
      ELSEIF((XP.GT.XSIZE+.01).OR.(YP.GT.YSIZE+.01)) THEN
        ID=2
        GO TO 90
      ENDIF
      IF(ICONT.EQ.1) CALL PLOT(XP,YP,ID)
      IF(ICONT.EQ.0) CALL CROSS(XP,YP,RAD(1))
      IF(ICONT.EQ.-1) CALL CIRCLE(XP,YP,RAD(2))
      IF(ICONT.EQ.-2) CALL TRINGL(XP,YP,RAD(3))
      IF(ICONT.EQ.-3) CALL SQAR(XP,YP,RAD(3))
      IF(ICONT.EQ.-4) CALL DIAM(XP,YP,RAD(3))
      IF(ICONT.EQ.-5) CALL ACROSS(XP,YP,RAD(1))
      IF(ICONT.EQ.-6) CALL UTRING(XP,YP,RAD(3))
      IF(ICONT.EQ.-7) CALL STAR(XP,YP,RAD(1))
      ID=0
      IF(I.LT.N) GO TO 90
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE RANGE(V,N,VMAX,IMAX,VMIN,IMIN)
C
C FINDS VMAX AND VMIN OF V,AND THEIR LOCATIONS IMAX,IMIN
C
      DIMENSION V(*)
      VMAX=V(1)
      IMAX=1
      VMIN=V(1)
      IMIN=1
      DO 10 I=1,N
      IF(VMAX.GT.V(I)) GO TO 5
      IMAX=I
      VMAX=V(I)
5     IF(VMIN.LT.V(I)) GO TO 10
      IMIN=I
      VMIN=V(I)
10    CONTINUE
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE CROSS(X,Y,R)
      NP=2
      CALL PLOT((X-R/2.),Y,NP)
      NP=0
      CALL PLOT((X+R/2.),Y,NP)
      NP=2
      CALL PLOT(X,(Y-R/2.),NP)
      NP=0
      CALL PLOT(X,(Y+R/2.),NP)
      RETURN
      END
C
C***********************************************************************
C
C      SUBROUTINE CIRCLE(X,Y,R)
C      DATA PI/3.14159/
C      NP=2
C      DO 20 I=1,19
C      TH=PI*(I-1)*20./180.
C      XP=X+R*SIN(TH)
C      YP=Y+R*COS(TH)
C      CALL PLOT(XP,YP,NP)
C      NP=0
C20    CONTINUE
C      RETURN
C      END
C
C***********************************************************************
C
      SUBROUTINE ELLIP(X,Y,AX,AY)
      DATA PI/3.14159/
      NP=2
      DO 20 I=1,19
      TH=PI*(I-1)*20./180.
      XP=X+AX*SIN(TH)
      YP=Y+AY*COS(TH)
      CALL PLOT(XP,YP,NP)
      NP=0
20    CONTINUE
      RETURN
      END
C
C**********************************************************************
C
      SUBROUTINE TRINGL(X,Y,R)
      DATA SRT3/1.732/
      CALL POLY(X-R,Y-R/SRT3,2)
      CALL POLY(X+R,Y-R/SRT3,0)
      CALL POLY(X,Y+(2.*R)/SRT3,0)
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE SQAR(X,Y,R)
      NP=2
      CALL POLY((X-R),(Y-R),NP)
      NP=0
      CALL POLY((X-R),(Y+R),NP)
      CALL POLY((X+R),(Y+R),NP)
      CALL POLY((X+R),(Y-R),NP)
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE DIAM(X,Y,R)
      DATA SRT2/1.414/
      R2=R*SRT2
      NP=2
      CALL POLY((X-R2),Y,NP)
      NP=0
      CALL POLY(X,(Y+R2),NP)
      CALL POLY((X+R2),Y,NP)
      CALL POLY(X,(Y-R2),NP)
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE ACROSS(X,Y,R)
      DATA SRT2/1.414/
      R2=R/SRT2
      NP=2
      CALL PLOT((X-R2/2.),(Y-R2/2.),NP)
      NP=0
      CALL PLOT((X+R2/2.),(Y+R2/2.),NP)
      NP=2
      CALL PLOT((X+R2/2.),(Y-R2/2.),NP)
      NP=0
      CALL PLOT((X-R2/2.),(Y+R2/2.),NP)
      RETURN
      END
C
C**********************************************************************
C
      SUBROUTINE UTRING(X,Y,R)
      DATA SRT3/1.732/
      CALL POLY(X-R,Y+R/SRT3,2)
      CALL POLY(X+R,Y+R/SRT3,0)
      CALL POLY(X,Y-(2.*R)/SRT3,0)
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE STAR(X,Y,R)
      DATA SRT2/1.414/
      NP=2
      CALL PLOT((X-R/2.),Y,NP)
      NP=0
      CALL PLOT((X+R/2.),Y,NP)
      NP=2
      CALL PLOT(X,(Y-R/2.),NP)
      NP=0
      CALL PLOT(X,(Y+R/2.),NP)
      R2=R/SRT2
      NP=2
      CALL PLOT((X-R2/2.),(Y-R2/2.),NP)
      NP=0
      CALL PLOT((X+R2/2.),(Y+R2/2.),NP)
      NP=2
      CALL PLOT((X+R2/2.),(Y-R2/2.),NP)
      NP=0
      CALL PLOT((X-R2/2.),(Y+R2/2.),NP)
      RETURN
      END

